

#reading in file that has all of the genes and go terms one line at a time

fil = "GO_annotation_wheat.TAB"
con = file(fil, "r")

lines = readLines(con)

list = ls()
i = 1 
while(i<length(lines)+1){
  list[i] = strsplit(lines[i],split = "\t")
  i = i + 1
}
list[1]

#creating one list for names and one list for Go Terms
nams = ls()
go = ls()
#extracting gene names and go terms. 
i = 1
while(i < length(lines)+1){
  nams[i] = list[[i]][1]
  go[i] = list[[i]][12]
  i = i + 1
}


#making data frame for genes and thier corresponding go terms. 

df = data.frame(geneID=unlist(nams),go=unlist(go))

#remove lines with no go terms
cut = is.na(df[,2])
df2 = df[!cut,]

#cut off names on top
df2 = df2[-1,]

df2[,1] = as.character(df2[,1])
df2[,2] = as.character(df2[,2])

#go through and make multiple entries for genes with multiple terms
goT = df2[3,2]
goT
gS = strsplit(goT,split = "; ")
gS
length(gS[[1]])

#looping through and getting all of the of the data organized 
i = 1
#c is the counter for the data frame
c = 1
nuGO = list()
nuNam = list()

#loop 
while(i < nrow(df2)+1){
  #get name and go term
  name = df2[i,1]
  go = df2[i,2]
  #split go terms
  gS = strsplit(go,split = "; ")
  #get number of go terms for gene
  L = length(gS[[1]])
  #set iterator for loop to add to list
  j = 1
  #put all go terms in list individually
  while(j < L+1)
  {
    nuGO[c] = gS[[1]][j]
    nuNam[c] = name
    #iterate J and C
    c = c + 1
    j = j + 1
  }
  i = i + 1
}

#fix up dataframe
nuDF = data.frame(geneID = as.character(unlist(nuNam)),go = as.character(unlist(nuGO)))
nuDF[,1] = as.character(nuDF[,1])
nuDF[,2] = as.character(nuDF[,2])

##################getting each go term meaning##################
library(GO.db)
Term("GO:0003677")

i = 1
def = list()
stop = nrow(nuDF)+1
while(i<stop){
  #get the meaning of the go term i
  def[i]=Term(nuDF[i,2])
  i = i + 1
}

#making final Data frame 
finalDF = data.frame(nuDF,def=unlist(def))
nuDF[1,1]
strsplit(nuDF[1,1],"\\.")
#removing the dots so I can merge the files
i = 1
noDot = list()
while(i<nrow(finalDF)+1){
  nuName = strsplit(finalDF[i,1],"\\.")[[1]][1]
  noDot[i]=nuName
  i = i + 1
}

finalDF[,1] = unlist(noDot)

write.csv(finalDF,file = "FUNC-E_input.csv")
finalDF[30,1]
